#!/usr/bin/perl

# Skrypt 9.3, 'search_movies.pl'

# Wprowad wymagane klauzule use.
use DBI;
use strict;

# Utwrz poczenie z baz danych.
my $user;
my $password;
my $dbh = DBI->connect('DBI:mysql:filmy_db;mysql_read_default_file=/home/lullman/.my.cnf', $user, $password, {RaiseError => 1});

# Jeli udoo si zestawi poczenie, przelij zapytanie.
if ($dbh) {

	# Pobierz sowa kluczowe.
	print "Wprowadz szukane slowo: ";
	my $term1 = <STDIN>;
	print "Wprowadz drugie szukane slowo: ";
	my $term2 = <STDIN>;

	# Utwrz zapytanie SQL.
	my $sql = "SELECT CONCAT(rezyserzy.imie, ' ', rezyserzy.nazwisko) AS Rezyser, tytul AS Tytul FROM rezyserzy, filmy WHERE rezyserzy.rezyser_id=filmy.rezyser_id";

	# Docz szukane sowa do zapytania.	
	if (length($term1) > 1) {
		chop($term1);
		$sql .= " AND ( (rezyserzy.nazwisko LIKE '%$term1%' OR rezyserzy.imie LIKE '%$term1%' OR filmy.tytul LIKE '%$term1%')";

		if (length($term2) > 1) {
			chop($term2);
			$sql .= " AND (rezyserzy.nazwisko LIKE '%$term2%' OR rezyserzy.imie LIKE '%$term2%' OR filmy.tytul LIKE '%$term2%')";
		}
		
		$sql .= ")";
	}

	# Przelij zapytanie.
	my $query = $dbh->prepare ($sql);
	my @row;
	my $n;
	if (defined($query)) {
		print "\n";
		$query->execute();
		for ($n=0; $n < $query->{'NUM_OF_FIELDS'}; $n++) {
			print @{$query->{'NAME'}}[$n];
			print "\t";
		}
		print "\n";
		while (@row = $query->fetchrow_array()) {
			foreach (@row) {
				print "$_ \t";
			}
			print "\n";
		}
	} else {
		print "Nie mozna wykonac zapytania z uwagi na zgloszony przez MySQL blad: " . DBI->errstr() . ". \n";
	}
	print "\n";
	
	# Zakocz zapytanie i poczenia z baz danych.
	$query->finish();
	$dbh->disconnect;
	
} else {
	print "Nie mona polaczyc sie z baza danych! \n";
}
